SystemOrganization addCategory: #'JQueryMobile-Scripting'!

!JQueryClass methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 15:04'!
currentPage
	"helper method to retrieve the current page DOM element"

	^ self expression: '#', self session currentPageId! !

!JQueryClass methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/24/2011 12:21'!
jqmDocument
	^ JQMDocumentScript jqInstanceDocument: self document! !

!JQueryClass methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/18/2011 18:03'!
mobile
	^ self create: JQMMobileScript! !

!JQueryClass methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/24/2011 12:21'!
page
	^ JQMPageScript jqInstanceCurrentPage: self currentPage! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/19/2011 12:13'!
jqmDataAt: anObject
	"Retreive arbitrary data associated with the matched elements, respecting any jQueryMobile namespace"
	"Within a JQueryMobile app, use in preference to JQueryInstance>>#dataAt:"
	
	self call: 'jqmData' with: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/19/2011 12:14'!
jqmDataAt: aKey put: aValue
	"Store arbitrary data associated with the matched elements, respecting any jQueryMobile namespace"
	"Within a JQueryMobile app, use in preference to JQueryInstance>>#dataAt:put:"
	
	self call: 'jqmData' with: aKey with: aValue! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/19/2011 12:14'!
jqmRemoveDataAt: aKey
	"Remove a previously-stored piece of data, respecting any jQueryMobile namespace"
	"Within a JQueryMobile app, use in preference to JQueryInstance>>#removeDataAt:"
		
	self call: 'jqmRemoveData' with: aKey! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:10'!
onSwipe: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'swipe' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:14'!
onSwipeLeft: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'swipeleft' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:14'!
onSwipeRight: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'swiperight' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:14'!
onTap: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'tap' do: anObject
! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:15'!
onTapHold: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'taphold' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:17'!
onVirtualMouseCancel: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vmousecancel' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:17'!
onVirtualMouseClick: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vclick' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:17'!
onVirtualMouseDown: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vmousedown' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:17'!
onVirtualMouseMove: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vmousemove' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:18'!
onVirtualMouseOver: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vmouseover' do: anObject! !

!JQueryInstance methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 16:18'!
onVirtualMouseUp: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self bind: 'vmouseup' do: anObject! !

JQScriptGenerator subclass: #JQMScriptGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMScriptGenerator methodsFor: 'adding' stamp: 'NickAger 10/24/2011 13:51'!
addOnPageInitializeScript: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*
	Triggered on the page being initialized, after initialization occurs. We recommend binding to this event instead of DOM ready() 
	because this will work regardless of whether the page is loaded directly or if the content is pulled into another page as part 
	of the Ajax navigation system."
	
	^ self loadScripts addLast: anObject! !

!JQMScriptGenerator methodsFor: 'actions' stamp: 'NickAger 10/26/2011 14:37'!
close: anHtmlRoot on: aDocument
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self writePageInitializeScriptWrappersOn: aDocument.
	
! !

!JQMScriptGenerator methodsFor: 'public' stamp: 'NickAger 10/22/2011 08:24'!
event: aString do: anObject on: aBrush
	anObject ifNil: [ ^ self ].
	self addOnPageInitializeScript: (JQueryInstance new
		id: aBrush ensureId;
		bind: aString do: anObject)! !

!JQMScriptGenerator methodsFor: 'private' stamp: 'NickAger 10/24/2011 16:53'!
writePageInitializeScriptWrappersOn: aDocument
	self loadScripts isEmpty
		ifTrue: [ ^ self ].
	
	self writeScriptTag: [ 
			aDocument nextPutAll: JQuery functionName; nextPutAll: '("#'; nextPutAll: self session currentPageId; nextPutAll: '").live("pageinit", function(){'. 
			self writePageInitializeScriptsOn: aDocument.
			aDocument nextPutAll: '});' ]
		on: aDocument	! !

!JQMScriptGenerator methodsFor: 'private' stamp: 'NickAger 10/24/2011 13:51'!
writePageInitializeScriptsOn: aDocument
	"Utility method to write the receivers load scripts onto aDocument."

	self loadScripts do: [ :each |
		aDocument nextPutAll: each greaseString; nextPut: $; ]! !

WAObject subclass: #JQMDocumentScript
	instanceVariableNames: 'jqInstanceDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMDocumentScript commentStamp: 'NickAger 10/22/2011 11:08' prior: 0!
JQueryMobile document scoped events!

!JQMDocumentScript class methodsFor: 'as yet unclassified' stamp: 'NickAger 10/22/2011 17:14'!
jqInstanceDocument: jqInstanceDocument
	^ self new 
		jqInstanceDocument: jqInstanceDocument;
		yourself! !

!JQMDocumentScript methodsFor: 'printing' stamp: 'NickAger 10/22/2011 17:14'!
greaseString
	^ String streamContents: [ :stream | stream javascript: self ]! !

!JQMDocumentScript methodsFor: 'printing' stamp: 'NickAger 10/22/2011 17:15'!
javascriptOn: aStream
	aStream javascript: self jqInstanceDocument! !

!JQMDocumentScript methodsFor: 'accessing' stamp: 'NickAger 10/22/2011 17:13'!
jqInstanceDocument
	^ jqInstanceDocument! !

!JQMDocumentScript methodsFor: 'accessing' stamp: 'NickAger 10/22/2011 17:13'!
jqInstanceDocument: anObject
	jqInstanceDocument := anObject! !

!JQMDocumentScript methodsFor: 'events-mobileinit' stamp: 'NickAger 10/24/2011 15:50'!
onMobileInit: anObject
	"probably shouldn't be used directly. Instead use JQMDecorator>>mobileInit:"
	^ self jqInstanceDocument bind: 'mobileinit' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pagechange' stamp: 'NickAger 10/22/2011 17:49'!
onPageBeforeChange: anObject
	^ self jqInstanceDocument bind: 'pagebeforechange' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pageload' stamp: 'NickAger 10/22/2011 17:50'!
onPageBeforeLoad: anObject
	^ self jqInstanceDocument bind: 'pagebeforeload' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pagechange' stamp: 'NickAger 10/22/2011 17:50'!
onPageChange: anObject
	^ self jqInstanceDocument bind: 'pagechange' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pagechange' stamp: 'NickAger 10/22/2011 17:50'!
onPageChangeFailed: anObject
	^ self jqInstanceDocument bind: 'pagechangefailed' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pageload' stamp: 'NickAger 10/22/2011 17:50'!
onPageLoad: anObject
	^ self jqInstanceDocument bind: 'pageload' do: anObject! !

!JQMDocumentScript methodsFor: 'events-pageload' stamp: 'NickAger 10/22/2011 17:50'!
onPageLoadFailed: anObject
	^ self jqInstanceDocument bind: 'pageloadfailed' do: anObject! !

WAObject subclass: #JQMPageScript
	instanceVariableNames: 'jqInstanceCurrentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMPageScript commentStamp: 'NickAger 10/22/2011 11:09' prior: 0!
JQueryMobile page scoped events!

!JQMPageScript class methodsFor: 'instance creation' stamp: 'NickAger 10/22/2011 17:14'!
jqInstanceCurrentPage: jqInstanceCurrentPage
	^ self new
		jqInstanceCurrentPage: jqInstanceCurrentPage;
		yourself! !

!JQMPageScript methodsFor: 'printing' stamp: 'NickAger 10/22/2011 16:53'!
greaseString
	^ String streamContents: [ :stream | stream javascript: self ]! !

!JQMPageScript methodsFor: 'printing' stamp: 'NickAger 10/22/2011 15:31'!
javascriptOn: aStream
	aStream javascript: self jqInstanceCurrentPage! !

!JQMPageScript methodsFor: 'accessing' stamp: 'NickAger 10/22/2011 15:12'!
jqInstanceCurrentPage
	^ jqInstanceCurrentPage! !

!JQMPageScript methodsFor: 'accessing' stamp: 'NickAger 10/22/2011 15:12'!
jqInstanceCurrentPage: aJQInstanceCurrentPage
	jqInstanceCurrentPage := aJQInstanceCurrentPage! !

!JQMPageScript methodsFor: 'events-initialisation' stamp: 'NickAger 10/22/2011 16:11'!
onBeforeCreate: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self jqInstanceCurrentPage bind: 'pagebeforecreate' do: anObject! !

!JQMPageScript methodsFor: 'events-transitions' stamp: 'NickAger 10/22/2011 16:11'!
onBeforeHide: anObject
	^ self jqInstanceCurrentPage bind: 'pagebeforehide' do: anObject! !

!JQMPageScript methodsFor: 'events-transitions' stamp: 'NickAger 10/22/2011 16:11'!
onBeforeShow: anObject
	^ self jqInstanceCurrentPage bind: 'pagebeforeshow' do: anObject! !

!JQMPageScript methodsFor: 'events-initialisation' stamp: 'NickAger 10/22/2011 16:10'!
onCreate: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self jqInstanceCurrentPage bind: 'pagecreate' do: anObject! !

!JQMPageScript methodsFor: 'events-transitions' stamp: 'NickAger 10/22/2011 16:10'!
onHide: anObject
	^ self jqInstanceCurrentPage bind: 'pagehide' do: anObject! !

!JQMPageScript methodsFor: 'events-initialisation' stamp: 'NickAger 10/22/2011 16:10'!
onInitialization: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	"as a speaker of British English, imagine the anguish I felt naming this Initialization with a 'z' rather than Initialisation"
	self jqInstanceCurrentPage bind: 'pageinit' do: anObject! !

!JQMPageScript methodsFor: 'events-orientation' stamp: 'NickAger 10/22/2011 13:56'!
onOrientationChange: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self jqInstanceCurrentPage bind: 'orientationchange' do: anObject! !

!JQMPageScript methodsFor: 'events-scroll' stamp: 'NickAger 10/22/2011 16:09'!
onScrollStart: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self jqInstanceCurrentPage bind: 'scrollstart' do: anObject! !

!JQMPageScript methodsFor: 'events-scroll' stamp: 'NickAger 10/22/2011 16:14'!
onScrollStop: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self jqInstanceCurrentPage bind: 'scrollstop' do: anObject! !

!JQMPageScript methodsFor: 'events-transitions' stamp: 'NickAger 10/22/2011 16:10'!
onShow: anObject
	self jqInstanceCurrentPage bind: 'pageshow' do: anObject! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:27'!
onSwipe: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'swipe'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:27'!
onSwipeLeft: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'swipeleft'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onSwipeRight: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'swiperight'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onTap: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'tap'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onTapHold: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'taphold'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseCancel: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vmousecancel'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseClick: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vclick'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseDown: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vmousedown'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseMove: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vmousemove'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseOver: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vmouseover'
		do: anObject
		on: self! !

!WATagBrush methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/21/2011 14:28'!
onVirtualMouseUp: anObject
	"*events>http://jquerymobile.com/test/docs/api/events.html*"
	self document scriptGenerator
		event: 'vmouseup'
		do: anObject
		on: self! !

!JQAjax methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/26/2011 17:19'!
jqmSerializeThisWithHidden
	"Serialize the receiving form element and a following hidden form element. This is required in case of a check-box or multi-select list.
	
	jQueryMobile inserts a div between the element and the checkbox so the 'standard' #serializeThisWithHidden doesn't work
	This is fragile to changes in jQueryMobile's markup"
	
	self serialize: (self jQuery this parent
		next: 'input:hidden';
		add: (self jQuery this))! !

!GRPackage class methodsFor: '*jquerymobile-scripting' stamp: 'NickAger 10/25/2011 11:21'!
jQueryMobileScripting
	^ self new
		name: 'JQueryMobile-Scripting';
		description: 'The jQueryMobile scripting support';
		addDependency: 'Seaside-RenderLoop';
		addDependency: 'JQuery-Core';
		addDependency: 'Seaside-Canvas';
		url: #seasideUrl;
		yourself! !

GRObject subclass: #JQMLoadPageOptions
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
allowSamePageTransition: aBoolean
	"default: false"
	
	"By default, changePage() ignores requests to change to the current active page. Setting this option to true, allows the request to execute. 
	Developers should note that some of the page transitions assume that the fromPage and toPage of a changePage request are different, so they may not animate as expected. 
	Developers are responsible for either providing a proper transition, or turning it off for this specific case."
	self optionAt: 'allowSamePageTransition' put: aBoolean! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
changeHash: aBoolean
	"default: true"
	
	"Decides if the hash in the location bar should be updated."
	self optionAt: 'changeHash' put: aBoolean! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:42'!
data: anObjectOrString 
	"default: undefined"
	
	"The data to send with an Ajax page request.
	Used only when the 'to' argument of #changePage:/#loadPage: is a URL."
	self optionAt: 'data' put: anObjectOrString! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
dataUrl: aString 
	"default: undefined"
	
	"The URL to use when updating the browser location upon changePage completion. 
	If not specified, the value of the data-url attribute of the page element is used."
	self optionAt: 'data-url' put: aString! !

!JQMLoadPageOptions methodsFor: 'printing' stamp: 'NickAger 10/18/2011 21:19'!
javascriptOn: aStream
	aStream javascript: self options! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:43'!
loadMsgDelay: aNumber 
	"default: 50 (ms) "
	
	"Forced delay before the loading message is shown. 
	This is meant to allow time for a page that has already been visited to be fetched from cache without a loading message."
	self optionAt: 'loadMsgDelay' put: aNumber! !

!JQMLoadPageOptions methodsFor: 'private' stamp: 'NickAger 10/18/2011 16:40'!
optionAt: aKey put: aValue
	^ self options at: aKey put: aValue! !

!JQMLoadPageOptions methodsFor: 'private' stamp: 'NickAger 10/18/2011 16:40'!
options
	^ options ifNil: [ options := GRSmallDictionary new ]! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/19/2011 10:38'!
pageContainer: aJQueryCollection 
	"default: $.mobile.pageContainer"
	
	"Specifies the element that should contain the page"
	self optionAt: 'pageContainer' put: aJQueryCollection! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:44'!
reloadPage: aBoolean 
	"default: false"
	
	"Forces a reload of a page, even if it is already in the DOM of the page container.
	Used only when the 'to' argument of #changePage: is a URL."
	self optionAt: 'reloadPage' put: aBoolean! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
reverse: aBoolean 
	"default: false"
	
	"Decides what direction the transition will run when showing the page."
	self optionAt: 'reverse' put: aBoolean! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:44'!
role: aString 
	"default: undefined"
	
	"The data-role value to be used when displaying the page. 
	By default this is undefined which means rely on the value of the @data-role attribute defined on the element."
	self optionAt: 'role' put: aString! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
showLoadMsg: aBoolean 
	"default: true"
	
	"Decides whether or not to show the loading message when loading external pages."
	self optionAt: 'showLoadMsg' put: aBoolean! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:45'!
transition: aString 
	"default: $.mobile.defaultPageTransition"
	
	"The transition to use when showing the page."
	self optionAt: 'transition' put: aString! !

!JQMLoadPageOptions methodsFor: 'options' stamp: 'NickAger 10/18/2011 16:44'!
type: aString 
	"default: 'get' "
	
	" Specifies the method ('get' or 'post') to use when making a page request.
	Used only when the 'to' argument of #changePage is a URL."
	self optionAt: 'type' put: aString! !

JSDecoration subclass: #JQMFixedToolBarsScript
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMFixedToolBarsScript methodsFor: 'as yet unclassified' stamp: 'NickAger 10/24/2011 12:07'!
greaseString
	^ String streamContents: [ :stream | stream javascript: self ]! !

!JQMFixedToolBarsScript methodsFor: 'methods' stamp: 'NickAger 10/24/2011 12:05'!
hide
	method := 'hide()'.
! !

!JQMFixedToolBarsScript methodsFor: 'methods' stamp: 'NickAger 10/24/2011 12:05'!
hide: immediately
	method := 'hide(', immediately asJavascript, ')'.
! !

!JQMFixedToolBarsScript methodsFor: 'as yet unclassified' stamp: 'NickAger 10/24/2011 12:26'!
javascriptOn: aStream
	aStream 
		javascript: self owner;
		nextPutAll: '.fixedToolbars.';
		nextPutAll: method! !

!JQMFixedToolBarsScript methodsFor: 'methods' stamp: 'NickAger 10/24/2011 12:04'!
show
	method := 'show()'.
! !

!JQMFixedToolBarsScript methodsFor: 'methods' stamp: 'NickAger 10/24/2011 12:04'!
show: immediately
	method := 'show(', immediately asJavascript, ')'.
! !

JQPlugin subclass: #JQMMobileScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Scripting'!

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:12'!
activeBtnClass
	^ self property: 'activeBtnClass'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:14'!
activeBtnClass: aString
	"default: 'ui-btn-active' "
		
	"The class used for 'active' button state, from CSS framework"
	self activeBtnClass; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/19/2011 12:28'!
activePage
	"Reference to the page currently in view."
	self property: 'activePage'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:46'!
activePageClass
	^ self property: 'activePageClass'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:47'!
activePageClass: aString
	"default: 'ui-page-active' "
		
	"The class assigned to page currently in view, and during transitions"
	self activePageClass; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:15'!
ajaxEnabled
	^ self property: 'ajaxEnabled'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:15'!
ajaxEnabled: aBoolean
	"default: true"
	
	"jQuery Mobile will automatically handle link clicks and form submissions through Ajax, when possible. 
	If false, url hash listening will be disabled as well, and urls will load as regular http requests."
	self ajaxEnabled; assign: aBoolean! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:39'!
autoInitializePage
	^ self property: 'autoInitializePage'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:41'!
autoInitializePage: aBoolean
	"default: true"
	
	"When the DOM is ready, the framework should automatically call $.mobile.initializePage. 
	If false, page will not initialize, and will be visually hidden until until $.mobile.initializePage is manually called."
	self autoInitializePage; assign: aBoolean! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/19/2011 11:00'!
changePageUrl: aUrlStringOrJQueryInstance options: aJQMLoadPageOptions
	"aStringOrJQueryInstance - EITHER: absolute or relative URL. ('about/us.html') OR  jQuery collection object. ($('#about'))"
	
	self call: 'changePage' with: aUrlStringOrJQueryInstance with: aJQMLoadPageOptions
! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:19'!
defaultDialogTransition
	^ self property: 'defaultDialogTransition'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:19'!
defaultDialogTransition: aString
	"default: 'pop' "
		
	"Set the default transition for dialog changes that use Ajax. Set to 'none' for no transitions by default."
	self defaultDialogTransition; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:17'!
defaultPageTransition
	^ self property: 'defaultPageTransition'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:17'!
defaultPageTransition: aString
	"default: 'slide' "
	
	"Set the default transition for page changes that use Ajax. Set to 'none' for no transitions by default."
	self defaultPageTransition; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/24/2011 12:22'!
fixedToolbars
	| toolbarScript |
	toolbarScript := JQMFixedToolBarsScript new.
	self addDecoration: toolbarScript.
	^ toolbarScript! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:24'!
gradeA: aFunction
	"a function that returns a boolean, default: a function returning the value of $.support.mediaquery"
		
	"Any support conditions that must be met in order to proceed."
	self property: 'gradeA';  assign: aFunction! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:16'!
hashListeningEnabled
	^ self property: 'hashListeningEnabled'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:16'!
hashListeningEnabled: aBoolean
	"default: true"
	
	"jQuery Mobile will automatically listen and handle changes to the location.hash. 
	Disabling this will prevent jQuery Mobile from handling hash changes, which allows you to handle them yourself, 
	or simply to use simple deep-links within a document that scroll to a particular ID.."
	self hashListeningEnabled; assign: aBoolean! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/20/2011 10:19'!
hidePageLoadingMessage
	"Hide the page loading message, which is configurable via $.mobile.loadingMessage"
	self call: #hidePageLoadingMsg! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/18/2011 19:37'!
initializePage
	^ self call: 'initializePage'! !

!JQMMobileScript methodsFor: 'printing' stamp: 'NickAger 10/24/2011 12:00'!
javascriptContentOn: aStream
	aStream 
		javascript: self owner;
		nextPutAll: '.mobile'! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/19/2011 11:01'!
loadPageUrl: aUrlStringOrJQueryInstance options:  aJQMLoadPageOptions
	"aStringOrJQueryInstance - EITHER: absolute or relative URL. ('about/us.html') OR  jQuery collection object. ($('#about'))"
	
	self call: 'loadPage' with: aUrlStringOrJQueryInstance with: aJQMLoadPageOptions
! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:21'!
loadingMessage
	^ self property: 'loadingMessage'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:21'!
loadingMessage: aString
	"default: 'loading' "
		
	"Set the text that appears when a page is loading. If set to false, the message will not appear at all."
	self loadingMessage; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:20'!
minScrollBack
	^ self property: 'minScrollBack'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:20'!
minScrollBack: aString
	"default: '150' "
		
	"Minimum scroll distance that will be remembered when returning to a page."
	self minScrollBack; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:29'!
namespace
	^ self property: 'ns'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:31'!
namespace: aNamespaceString
	"default: '' "
		
	"The namespace used in data- attributes, for example, data-role. Can be set to anything, including a blank string which is the default. 
	When using, it's clearest if you include a trailing dash, such as 'mynamespace-' which maps to data-mynamespace-foo='...'.
	NOTE: if you're using data- namespacing, you'll need to manually update/override one selector in the theme CSS. 
	The following data selectors should incorporate the namespace you're using:
		.ui-mobile [data-mynamespace-role=page], .ui-mobile [data-mynamespace-role=dialog], .ui-page { ..."
	self namespace; assign: aNamespaceString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/19/2011 10:37'!
pageContainer
	^ self property: 'pageContainer'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:21'!
pageLoadErrorMessage
	^ self property: 'pageLoadErrorMessage'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:22'!
pageLoadErrorMessage: aString
	"default: 'Error Loading Page' "
		
	"Set the text that appears when a page fails to load through Ajax."
	self pageLoadErrorMessage; assign: aString! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/20/2011 10:19'!
showPageLoadingMessage
	"Show the page loading message, which is configurable via $.mobile.loadingMessage"
	self call: #showPageLoadingMsg! !

!JQMMobileScript methodsFor: 'methods' stamp: 'NickAger 10/18/2011 17:02'!
silentScrollToYPos: aNumber 
	"default: 0"

	"Scroll to a particular Y position without triggering scroll event listeners."
	self call: 'silentScroll' with: aNumber! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:44'!
subPageUrlKey
	^ self property: 'subPageUrlKey'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 19:44'!
subPageUrlKey: aString
	"default: 'ui-page' "
		
	"The url parameter used for referencing widget-generated sub-pages (such as those generated by nested listviews). 
	Translates to to example.html&ui-page=subpageIdentifier. 
	The hash segment before &ui-page= is used by the framework for making an Ajax request to the URL where the sub-page exists."
	self subPageUrlKey; assign: aString! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:18'!
touchOverflowEnabled
	^ self property: 'touchOverflowEnabled'! !

!JQMMobileScript methodsFor: 'properties' stamp: 'NickAger 10/18/2011 20:18'!
touchOverflowEnabled: aBoolean
	"default: false"
	
	"Enable pages to have self-contained native scrolling and fixed toolbars in devices that support the overflow-scrolling: touch; property."
	self touchOverflowEnabled; assign: aBoolean! !
